<?php
/*
Plugin Name: HowToGeek - WP Notifier
Plugin URI: http://www.howtogeek.com
Description: Plugin to support How-To Geek's WP Comment Notifer
Version: 0.1
Author: The Geek
*/

function geekwpnotifier_escape(&$array) {
	global $wpdb;

	foreach ( (array) $array as $k => $v ) {
		if (is_array($v)) {
			utwrpc_escape($array[$k]);
		} else if (is_object($v)) {
			//skip
		} else {
			$array[$k] = $wpdb->escape($v);
		}
	}
}

function geek_getComments($args){
	global $wpdb;
	geekwpnotifier_escape($args);

  $blog_ID     = $args[0];
  $user_login  = $args[1];
  $user_pass   = $args[2];

	if (!user_pass_ok($user_login, $user_pass)) {
    $error = new IXR_Error(403, 'Bad login/pass combination.');
    return $error;    
  }

  set_current_user(0, $user_login);
  if (!current_user_can('moderate_comments') ){
    $error = new IXR_Error(403, 'You are not allowed to moderate comments.');
    return $error;    
	}else{		
		$commentcount = $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->comments . " WHERE comment_approved = '0';");
	}
	return $commentcount;	
}

add_filter('xmlrpc_methods', 'attach_geek_wpnotifier');
function attach_geek_wpnotifier($methods) {
	$methods['geek.getCommentModerationCount'] = 'geek_getComments';
	return $methods;
}

?>